# cakes #

在Javascript中轻松实现**class-like**方式的继承，就像PHP，Java等语言一样的面向对象实现。

## 例子 ##

```Javascript
var Class = require('cakes').Class;

// 定义Preson类
var Preson = Class({

    __contrustor: function(name, age, gender) {
        this.name = name;
        this.age = age;
        this.gender = gender;
    }

    intro: function() {
        console.log('My name is ' + this.name);
    }
});

// 定义Man类，继承Preson类
var Man = Class({

    __constructor: function(name, age) {
        this.super('__contructor', name, age, 'male');
    }

}, Preson);


var m = new Man('Emilly', 18);
m.say(); // My name is Emilly
```

## __construstor ##

实例化类时将会调用这个构造方法，如果父类中也有`__constructor`，则会先调用父类中的`__constructor`，这个特性类似于PHP和Java中的构造函数。

## super ##

`super(methodName, args...)`，这个方法的第一个参数接受的是父类中存在的方法名，其他参数作为形参传递给父类函数。

## TODO ##

有时间就写。

* [ ] 实现继承

## License ##

(The MIT License)

Copyright (c) 2014 happen-zhang <zhanghaipeng404@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
'Software'), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
